<template>
  <div class="ColorChooser">
    <Button
      class="ColorChooser__ColorButton p-button-outlined"
      :class="{
        'ColorChooser__ColorButton--none': !props.modelValue,
      }"
      :style="`--color-chooser-value: ${props.modelValue};`"
      :title="t('component.colorChooser.change')"
      aria:haspopup="true"
      aria-controls="overlay_panel"
      :icon="props.modelValue ? null : 'mdi mdi-palette-outline'"
      @click="toggle"
    />

    <OverlayPanel id="overlay_panel" ref="op">
      <div class="ColorChooser__Overlay">
        <div class="ColorChooser__Options">
          <Button
            v-for="preferredColor of props.preferred"
            :key="preferredColor"
            class="ColorChooser__ColorButton"
            :style="`--color-chooser-value: ${preferredColor};`"
            :title="t('component.colorChooser.choose')"
            @click="chooseColor(preferredColor)"
          />
        </div>
        <ColorPicker
          v-if="props.allowCustom"
          v-model="color"
          :inline="true"
          format="hex"
          class="ColorChooser__Picker"
        />
        <Button
          v-if="props.allowRemove"
          :label="t('component.colorChooser.none')"
          icon="mdi mdi-close"
          @click="color = null"
        />
      </div>
    </OverlayPanel>
  </div>
</template>

<script lang="ts" setup>
import Button from 'primevue/button/Button.vue'
import OverlayPanel from 'primevue/overlaypanel/OverlayPanel.vue'
import ColorPicker from 'primevue/colorpicker/ColorPicker.vue'
import { useI18n } from 'vue-i18n'
import { computed, ref } from 'vue'

const props = defineProps<{
  modelValue?: string | undefined | null
  preferred?: string[]
  allowCustom?: boolean
  allowRemove?: boolean
}>()

const emits = defineEmits<{
  /**
   * Updates model
   */
  (e: 'update:modelValue', color: string): void

  /**
   * Trigger if color is removed
   */
  (e: 'removeColor'): void
}>()

const color = computed<string | null>({
  get: () => props.modelValue || '',
  set: (color: string | null) => {
    if (!color) {
      emits('removeColor')
      toggle()
    } else {
      emits('update:modelValue', color.charAt(0) === '#' ? color : `#${color}`)
    }
  },
})

function chooseColor(newValue: string | null) {
  color.value = newValue
  toggle()
}

const { t } = useI18n()

const op = ref()
const toggle = (event?: Event) => op.value.toggle(event)
</script>

<style lang="scss" scoped>
@use 'src/style/variables' as v;

.ColorChooser {
  $root: &;

  &__ColorButton {
    display: block;
    min-width: 1rem;
    min-height: 1rem;

    &:not(#{$root}__ColorButton--none) {
      border: 1px solid var(--surface-300);
      background-color: var(--color-chooser-value);
    }
  }

  &__Options {
    display: grid;
    grid-template-columns: repeat(4, minmax(min-content, 1fr));
    gap: v.$spacing-2;
    justify-items: start;
  }

  &__Overlay {
    display: flex;
    flex-direction: column;
    gap: v.$spacing;
  }
}
</style>
